require 'tzinfo'
require 'sg_common/core_ext/support'

# This class contains Date extensions used by SG
class Date
  SG_TIME_OFFSET = 5 # SG date start at 5am ET

  def utc_time_offset(time_zone)
    (self.beginning_of_sg_day(time_zone) - self.to_time(:utc).midnight) / 3600
  end

  def beginning_of_sg_day(time_zone)
    timezone = TZInfo::Timezone.get(time_zone)

    timezone.local_to_utc(Time.local(year, month, day, SG_TIME_OFFSET, 0, 0, 0))
  end

  def end_of_sg_day(time_zone)
    (self + 1.day).beginning_of_sg_day(time_zone)
  end

  def hours_in_sg_day(time_zone)
    ((end_of_sg_day(time_zone) - beginning_of_sg_day(time_zone)) / 1.hour).round
  end

  def dt
    strftime('%Y%m%d')
  end
end
